// awy_dat.h
#ifndef _awy_dat_H_
#define _awy_dat_H_
#ifdef __cplusplus
extern "C" {
#endif

#define  MX_FIX_NAME 8

typedef struct tagFGAWY {
   LE link; // double linked list - MUST BE FIRST
   int index;
   int type; // 1=low altitude; 2=high altitude airway
   int base; // base altitude
   int top;  // top altitude
   double latst, lonst;
   double latend, lonend;
   char id_start[MX_FIX_NAME+1];
   char id_end[MX_FIX_NAME+1];
   char name[MX_FIX_NAME+1];
}FGAWY, * PFGAWY;

extern int Load_Awy_File( char * pfile );
extern PLE Get_Awy_List( void );
extern void Del_Awy_List( void );
extern int Get_Awy_in_Bounds( double n, double s, double e, double w, PLE ph );

#ifdef __cplusplus
}
#endif
#endif _awy_dat_H_
// eof - awy_dat.h
