// gshhs_main.c

#include "gshhs_win.h"

#define  DEF_IN_FILE    "..\\data_1.6\\gshhs_i.b"
//#define  DEF_OUT_FILE   "tempi.bmp"
//#define  DEF_OUT_FILE   "tempimerc.bmp"
//#define  DEF_OUT_FILE   "tempi4r.bmp"
#define  DEF_OUT_FILE   "tempi8.bmp"

//#define  DEF_IN_FILE    "..\\data_1.6\\wdb_rivers_h.b"
//#define  DEF_OUT_FILE   "temprivi.bmp"

//#define  DEF_IN_FILE    "..\\data_1.6\\wdb_borders_i.b"
//#define  DEF_IN_FILE    "..\\data_1.6\\gshhs_h.b"
//#define  DEF_IN_FILE    "..\\data_1.6\\gshhs_i.b"

// others tried
//#define  DEF_IN_FILE    "..\\data_1.3\\gshhs_i.b"
//#define  DEF_IN_FILE    "..\\gshhs_isl\\gshhs_isle.shx"
//#define DEF_IN_FILE "..\\GMT\\share\\coast\\binned_border_c.cdf"
char * def_file = DEF_IN_FILE;

int bShowRanges = 0; // output the RANGES
BOOL bDoReverseTest = TRUE;

static PGSINFO _s_pgsi = NULL;

// forward reference
void only_exit( int i );

void pgm_exit( int ret )
{
   PGSINFO pgsi = _s_pgsi;

   Kill_Lists();
   if( pgsi ) {
      Close_Map_File_WIN32( &pgsi->mv );
      if( pgsi->bmpinfo.range.pblock )
         MFREE(pgsi->bmpinfo.range.pblock);
      pgsi->bmpinfo.range.pblock = NULL;
      MFREE( pgsi );
      _s_pgsi = NULL;
   }

#ifndef  NO_ADD_FG_DATA
   Kill_Linked_Lists();
#endif // #ifndef  NO_ADD_FG_DATA

   only_exit(ret);
}


#define  TLat(a)  Trans_Lat(pgsi, a)
#define  TLon(a)  Trans_Lon(pgsi, a)

long Trans_Lat( PGSINFO pgsi, double lat )
{
   double scale = (double)pgsi->bmpinfo.range.scale;
   //int ilat = (int)(((lat +  90.0) * scale * 2.0) + 0.5); // range 0 to 180
   int ilat = (int)(((lat +  90.0) * scale) + 0.5); // range 0 to 180
   return ilat;
}
long Trans_Lon( PGSINFO pgsi, double lon )
{
   double scale = (double)pgsi->bmpinfo.range.scale;
   int ilon = (int)(((lon + 180.0) * scale) + 0.5); // range 0 to 360
   return ilon;
}

void Show_Memory_Problem( PGSINFO pgsi, size_t insize )
{
   PBMPINFO pbmi = &pgsi->bmpinfo;
   PGSRANGE pgsr = &pbmi->range;
   size_t size = insize;
   double dscale = (double) pgsi->bmpinfo.range.scale;
   long width = pgsr->width;
   long height = pgsr->height;
   PBYTE pb;
   sprtf("ERROR: Memory allocation of %d bytes FAILED!"MEOR, size );
   sprtf("That is %d x %d, using scale %d ... moment, checking ..."MEOR,
      pgsr->width, pgsr->height, pgsi->bmpinfo.range.scale );
   pb = NULL;
   while( pb == NULL ) {
      dscale = dscale / 2.0;
      size = ((int) ((pgsr->dwid * dscale) + 1.5)) * ((int) ((pgsr->dhgt * dscale) + 1.5));
      pb = (PBYTE)MALLOC(size);
   }
   MFREE(pb);
   sprtf( "Things MAY work if scale is reduced to %d or less ..."MEOR,
      (int)dscale );
   sprtf( "That is a %d byte allocation ..."MEOR, size );
   sprtf( "Or reduce the width %3.1f, or heigth %3.1f degrees by min/max lat/lon..."MEOR,
      pgsr->dwid, pgsr->dhgt );
   sprtf( "Or do NOT request a USER bitmap be written ..."MEOR );
   pb = NULL;
}

// already checked USER RANGE is above ZERO
// Get the N, S, E, W limits to work with
void Get_N_S_E_W_Limits( PGSINFO pgsi )
{
   PBMPINFO pbmi = &pgsi->bmpinfo;
   PGSRANGE pgsr = &pbmi->range;
   double s = pgsr->range * 1000.0; // conver to METERS 
   double lat, lon;
   double h, dbl, h2;
   lat = pgsr->centlat;
   lon = pgsr->centlon;

   h = 270.0;
   geo_direct_wgs_84 ( lat, lon, h, s,
      &dbl, &pgsr->w, &h2 );   // go WEST (270), for ???m, to w
   h = 90.0;
   geo_direct_wgs_84 ( lat, lon, h, s,
      &dbl, &pgsr->e, &h2 );   // go EAST (90), for 100m, to be
   h = 0.0;
   geo_direct_wgs_84 ( lat, lon, h, s,
      &pgsr->n, &dbl, &h2 );   // go NORTH (0), for 100m, to bn
   h = 180.0;
   geo_direct_wgs_84 ( lat, lon, h, s,
      &pgsr->s, &dbl, &h2 );

   if( VERB1(pgsi) ) {
      sprtf("Using range %3.1f Km, set N %3.6f, S %3.6f, E %3.6f, W %3.6f\n",
         pgsr->range,
         pgsr->n, pgsr->s, pgsr->w, pgsr->e );
   }
   h = 0.0;
}

// a check of the INPUT arguments
void Check_Args( PGSINFO pgsi )
{
   PBMPINFO pbmi = &pgsi->bmpinfo;
   PGSRANGE pgsr = &pbmi->range;
   PLE ph = Get_File_List();
   if( pbmi->bmpname[0] )  // given a USER bitmap to write
   {
      // if an OUPUT USER BITMAP FILE
      if( pgsr->range > 0.0 ) {
         // we were GIVEN a RANGE, and LAT,LON center - USE IT
         if( Lat_In_Range( pgsr->centlat ) && Lon_In_Range( pgsr->centlon ) )
         {
            Get_N_S_E_W_Limits( pgsi );
         } else {
            sprtf("ERROR: Center lat,lon, %3,6f, %3.6f, OUT OF WORLD view!\n",
               pgsr->centlat, pgsr->centlon );
            pgm_exit(1);
         }
      }
      if( Lat_In_Range( pgsr->n )&&
          Lat_In_Range( pgsr->s )&&
          Lon_In_Range( pgsr->e )&&
          Lon_In_Range( pgsr->w )&&
          ( pgsr->s < pgsr->n )&&
          ( pgsr->w < pgsr->e ))
      {
         int   verb = pgsi->verbosity; // extract verbosity
         double dscale = (double)pgsi->bmpinfo.range.scale;
         size_t size;
#ifndef  NDEBUG
         pgsi->verbosity = 9; // set MAXIMUM
#endif // !NDEBUG

         pgsr->dwid = pgsr->e - pgsr->w;  // width, in degrees
         pgsr->dhgt = pgsr->n - pgsr->s;  // height, in degrees
         pgsr->centerlat = (pgsr->n + pgsr->s) / 2.0;
         pgsr->centerlon = (pgsr->e + pgsr->w) / 2.0;

         // get integral height and width, adding 1
         pgsr->height = (int) ((pgsr->dhgt * dscale) + 1.5);
         if(pgsr->height == 0)
            pgsr->height = 1;
         pgsr->width  = (int) ((pgsr->dwid * dscale) + 1.5);
         if(pgsr->width == 0)
            pgsr->width = 1;
         // allocate the memory
         size = pgsr->width * pgsr->height;
         if( pgsr->autoscale && ((size / 1024) < pgsr->bmpsize)) {
            long width = pgsr->width;
            long height = pgsr->height;
            long bmpsize = (long)(pgsr->bmpsize * 1024);
            if( VERB1(pgsi) ) {
               sprtf( "Adjusting scale from %d, ", pgsi->bmpinfo.range.scale );
            }
            while( (width * height) < bmpsize )
            {
               dscale += 1.0;
               height = (long) ((pgsr->dhgt * dscale) + 1.5);
               width  = (long) ((pgsr->dwid * dscale) + 1.5);
            }
            pgsi->bmpinfo.range.scale = (long)dscale;
            pgsr->height = (long) ((pgsr->dhgt * dscale) + 1.5);
            pgsr->width  = (long) ((pgsr->dwid * dscale) + 1.5);
            size = pgsr->width * pgsr->height;
            if( VERB1(pgsi) ) {
               sprtf( "to scale %d, giving BMP size approx. %dKB ...\n",
                  pgsi->bmpinfo.range.scale,
                  size / 1024 );
            }
         }

         Get_DPP_at_Center( pgsi ); // compute CENTER degrees / pixel
         if( VERB8(pgsi) || bShowRanges ) {
            sprtf( "v8: Degrees per PIXEL NS=%3.6f (%3.6f), EW=%3.6f (%3.6f)\n",
               pgsr->degspplat, pgsr->dhgt / (double)pgsr->height,
               pgsr->degspplon, pgsr->dwid / (double)pgsr->width );
         }

         pgsr->pblock = (PBYTE)MALLOC(size);  // ALLOCATE BLOCK FOR POINT ACCUMULATION
         if( !pgsr->pblock ) { Show_Memory_Problem( pgsi, size ); }
         CHKMEM(pgsr->pblock, size);   // store bits in here
         ZeroMemory(pgsr->pblock, size);
         // establish OFFSET ==========================
         pgsr->ailon = TLon(pgsr->w); // range 0 to 360
         pgsr->ailat = TLat(pgsr->s); // range 0 to 180
         // ===========================================
         // get pixel BOUNDARIES ...
         // =====================================================================
         // top/left
         Get_BMP_iLatLon( pgsi, pgsr->n, pgsr->w, &pgsr->TLilat, &pgsr->TLilon );
         // bottom/right
         Get_BMP_iLatLon( pgsi, pgsr->s, pgsr->e, &pgsr->BRilat, &pgsr->BRilon );
         // top/right
         Get_BMP_iLatLon( pgsi, pgsr->n, pgsr->e, &pgsr->TRilat, &pgsr->TRilon );
         // bottom/left
         Get_BMP_iLatLon( pgsi, pgsr->s, pgsr->w, &pgsr->BLilat, &pgsr->BLilon );
         // =====================================================================

         if( !pgsi->bmpinfo.mercator ) {
            int tlat;
            // but this may NOT be the actual BOUNDARIES
            if(( pgsr->n > 0.0 )&&( pgsr->s < 0.0 )) {
               // then 0.0 lat is widest
               Get_BMP_iLatLon( pgsi, 0.0, pgsr->e, &tlat, &pgsr->BRilon );
            } else if( pgsr->n < 0.0 ) {
               // then North is WIDEST
               Get_BMP_iLatLon( pgsi, pgsr->n, pgsr->e, &tlat, &pgsr->BRilon );
            }
         }
         if( VERB8(pgsi) || bShowRanges ) {
            int ilat, ilon;
            BOOL  merc = pgsi->bmpinfo.mercator;
            //double lat, lon;
             sprtf( "v8: Limits are in range ... Mercator %s\n",
                ( merc ? "On" : "Off" ));
             sprtf( "v8: Lat max %3.7f, min %3.7f, "
                "Lon min %3.7f, max %3.7f\n",
                pgsr->n, pgsr->s, pgsr->w, pgsr->e );
             sprtf( "v8: Degrees height %3.7f, width %3.7f, scale %d (BMP=%u bytes)\n",
                pgsr->dhgt, pgsr->dwid,
                pgsr->scale, size );
             sprtf( "v8: Integral pixels y %d, x %d, (adj %d,%d)\n",
                pgsr->height, pgsr->width, 
                pgsr->ailat, pgsr->ailon );

             // SHOW pixel boundaries
             sprtf( "v8: TL Lat %3.7f, TL Lon %3.7f, translates to %d, %d\n",
                pgsr->n, pgsr->w, pgsr->TLilat, pgsr->TLilon);
             Get_BMP_iLatLon( pgsi, pgsr->centerlat, pgsr->centerlon, &ilat, &ilon );
             sprtf( "V8: CT Lat %3.7f, CT Lon %3.7f, translates to %d, %d"MEOR,
                pgsr->centerlat, pgsr->centerlon, ilat, ilon );
             sprtf( "v8: BR Lat %3.7f, BR Lon %3.7f, translates to %d, %d\n",
                pgsr->s, pgsr->e, pgsr->BRilat, pgsr->BRilon);
             Get_BMP_iLatLon( pgsi, pgsr->n, pgsr->e, &ilat, &ilon );
             sprtf( "V8: T- Lat %3.7f, -R Lon %3.7f, translates to %d, %d"MEOR,
                pgsr->n, pgsr->e, ilat, ilon );
             Get_BMP_iLatLon( pgsi, pgsr->s, pgsr->w, &ilat, &ilon );
             sprtf( "V8: B- Lat %3.7f, -L Lon %3.7f, translates to %d, %d"MEOR,
                pgsr->s, pgsr->w, ilat, ilon );
             Get_BMP_iLatLon( pgsi, pgsr->centerlat, pgsr->e, &ilat, &ilon );
             sprtf( "V8: CT Lat %3.7f, -R Lon %3.7f, translates to %d, %d"MEOR,
                pgsr->centerlat, pgsr->e, ilat, ilon );
             Get_BMP_iLatLon( pgsi, pgsr->centerlat, pgsr->w, &ilat, &ilon );
             sprtf( "V8: CT Lat %3.7f, -L Lon %3.7f, translates to %d, %d"MEOR,
                pgsr->centerlat, pgsr->w, ilat, ilon );

             sprtf( "v8: Mercator ON ...\n" );
             pgsi->bmpinfo.mercator = 1;
             Get_BMP_iLatLon( pgsi, pgsr->n, pgsr->w, &ilat, &ilon );
             sprtf( "v8: Lat %3.7f, Lon %3.7f, translates to %d, %d\n",
                pgsr->n, pgsr->w, ilat, ilon);
             Get_BMP_iLatLon( pgsi, pgsr->s, pgsr->e, &ilat, &ilon );
             sprtf( "v8: Lat %3.7f, Lon %3.7f, translates to %d, %d\n",
                pgsr->s, pgsr->e, ilat, ilon);

             sprtf( "v8: Mercator OFF ...\n" );
             pgsi->bmpinfo.mercator = 0;
             Get_BMP_iLatLon( pgsi, pgsr->n, pgsr->w, &ilat, &ilon );
             sprtf( "v8: Lat %3.7f, Lon %3.7f, translates to %d, %d\n",
                pgsr->n, pgsr->w, ilat, ilon);
             Get_BMP_iLatLon( pgsi, pgsr->s, pgsr->e, &ilat, &ilon );
             sprtf( "v8: Lat %3.7f, Lon %3.7f, translates to %d, %d\n",
                pgsr->s, pgsr->e, ilat, ilon);
             pgsi->bmpinfo.mercator = merc;

             sprtf( "v8: Full BITMAP items ... Mercator %s\n",
                ( pgsi->bmpinfo.mercator ? "On" : "Off" ));
             sprtf( "v8: Full tl=(%d,%d) br=(%d,%d), Lims tl=(%d,%d) br=(%d,%d)\n",
                TLon(-180.0),
                TLat( 90.0),
                TLon(180.0),
                TLat(-90.0),
                TLon(pgsr->w),
                TLat(pgsr->n),
                TLon(pgsr->e),
                TLat(pgsr->s));
             Trans_Lat_Lon( pgsi, 90.0, -180.0, &ilat, &ilon );
             sprtf( "v8: Full tl(90,-180)=(%d,%d) ", ilat, ilon );
             Trans_Lat_Lon( pgsi, -90.0, 180.0, &ilat, &ilon );
             sprtf( "br(-90,180)=(%d,%d)\n", ilat, ilon );

             //Trans_Lat_Lon( pgsi, pgsr->n, pgsr->w, &ilat, &ilon );
             //sprtf( "v8: Limits tl=(%d,%d) ", ilat, ilon );
             //Trans_Lat_Lon( pgsi, pgsr->s, pgsr->e, &ilat, &ilon );
             //sprtf( "br=(%d,%d)\n", ilat, ilon );
             if( bDoReverseTest || VERB8(pgsi) ) {
                double lat, lon;
                //double tlat, tlon;
                //int  tilat, tilon, i;
                sprtf( MEOR"v8: Doing 'reverse' test - pixel to lat,lon ..."MEOR );
                sprtf( "For TL %3.6f, %3.6f, pixel %d, %d"MEOR,
                   pgsr->n, pgsr->w, pgsr->TLilat, pgsr->TLilon );
                BMP_iLatLon_2_latlon( pgsi, &lat, &lon, pgsr->TLilat, pgsr->TLilon );
                Get_BMP_iLatLon( pgsi, lat, lon, &ilat, &ilon );
                sprtf( "Got TL %3.6f, %3.6f, pixel %d, %d ... ",
                   lat, lon, ilat, ilon );
                if( ilat != pgsr->TLilat ) {
                   sprtf( " (ilat diff = %d)", abs(ilat - pgsr->TLilat));
                } else {
                   sprtf( " (ilat ok)" );
                }
                if( ilon != pgsr->TLilon ) {
                   sprtf( " (ilon diff = %d)", abs(ilon - pgsr->TLilon));
                } else {
                   sprtf( " (ilon ok)" );
                }
                sprtf(MEOR);

                sprtf( "For BR %3.6f, %3.6f, pixel %d, %d"MEOR,
                   pgsr->s, pgsr->e, pgsr->BRilat, pgsr->BRilon );
                BMP_iLatLon_2_latlon( pgsi, &lat, &lon, pgsr->BRilat, pgsr->BRilon );
                Get_BMP_iLatLon( pgsi, lat, lon, &ilat, &ilon );
                sprtf( "Got BR %3.6f, %3.6f, pixel %d, %d ...",
                   lat, lon, ilat, ilon );
                if( ilat != pgsr->BRilat ) {
                   sprtf( " (ilat diff = %d)", abs(ilat - pgsr->BRilat));
                } else {
                   sprtf( " (ilat ok)" );
                }
                if( ilon != pgsr->BRilon ) {
                   sprtf( " (ilon diff = %d)", abs(ilon - pgsr->BRilon));
                } else {
                   sprtf( " (ilat ok)" );
                }
                sprtf(MEOR);

             }
             pgsi->verbosity = verb; // set back to what it was
             verb = 0;
          }

#ifndef NO_ADD_FG_DATA
          Load_FG_Data( pgsi );
#endif // #ifdef ADD_FG_DATA

         if( pgsi->bmpinfo.addscale )
            Add_BMP_Scale( pgsi );  // write a small SCALE legend to TR & BL ...

      } else {
         sprtf("ERROR: Range min/max out of world view!\n"
            "Lat max %f, min %f, "
            "Lon min %f, max %f\n",
            pgsr->n, pgsr->s, pgsr->w, pgsr->e );
         pgm_exit(1);
      }
   }

   // establish a DEFAULT file, if NO ARGS GIVEN!!!
   if( IsListEmpty(ph) ) {
      // if( !pgsi->fn[0] ) strcpy( pgsi->fn, def_file);
      Add_2_File_List( def_file );
   }
}

extern void Bitmap_2_Bits(void);

void Show_Time( void )
{
   time_t   tm;
   time( &tm );
   //timer = SetBTime();
   sprtf( "Run Time %s", ctime(&tm) );
}

#ifdef   WIN32
void Run_Process( PGSINFO pgsi )
{
   static STARTUPINFO sui;
   static PROCESS_INFORMATION pi;
   char * cp = GetNxtBuf();

   sprintf(cp, "%s %s", pgsi->bmpinfo.exename, pgsi->bmpinfo.bmpname);
   ZeroMemory(&sui, sizeof(STARTUPINFO));
   ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
   sui.cb = sizeof(STARTUPINFO);
   if( VERB1(pgsi) )
      sprtf( "Executing [%s] ...\n", cp );

   if( CreateProcess( NULL, //  LPCTSTR lpApplicationName,
         cp,      // LPTSTR lpCommandLine,
         NULL,    // LPSECURITY_ATTRIBUTES lpProcessAttributes,
         NULL,    // LPSECURITY_ATTRIBUTES lpThreadAttributes,
         FALSE,   // BOOL bInheritHandles,
         0,       // DWORD dwCreationFlags,
         NULL,    // LPVOID lpEnvironment,
         NULL,    // LPCTSTR lpCurrentDirectory,
         &sui,    // LPSTARTUPINFO lpStartupInfo,
         &pi ) ) {   // LPPROCESS_INFORMATION lpProcessInformation
         CloseHandle(pi.hProcess);
         CloseHandle(pi.hThread);
   } else {
      sprtf( "WARNING: FAILED to execute [%s]!\n", cp );
   }
}
#endif // #ifdef   WIN32

int main (int argc, char **argv)
{
   int   iret = 0;
   BOOL  bmp;
   PTSTR pfile;
   int   item, cnt;
   PGSINFO pgsi;
   PTSTR pb;

   _s_pgsi = (PGSINFO)MALLOC( sizeof(GSINFO) );
   CHKMEM(_s_pgsi,( sizeof(GSINFO) ));

   pgsi = _s_pgsi;
   ZeroMemory(pgsi,sizeof(GSINFO));

   Show_Time();
   // Bitmap_2_Bits(); // use to generate data in gshhs_data.c

   Init_GSINFO(pgsi);

   Clear_lon_lat( pgsi );

   Process_Args( argc, argv, pgsi);

   Check_Args( pgsi );

   bmp = (pgsi->bmpinfo.bmpname[0] ? TRUE : FALSE);  // write BITMAP

   cnt = Get_File_List_Count();
   if( !cnt ) {
      sprtf( "WARNING: No INPUT file name(s) found!\n" );
      pgm_exit(EXIT_FAILURE);
   }
   
#ifndef  NO_ADD_FG_DATA
   if( bmp )
      Paint_FG_Data( pgsi );  // add any FG DATA
#endif // #ifndef  NO_ADD_FG_DATA

   item = 1;
   while( (pfile = Get_File_List_File_Ptr(item)) != NULL ) {
      if( !Map_File_WIN32( pfile, &pgsi->mv ) ) {
		   sprtf ( "WARNING: Could not find file %s.\n", pfile );
		   iret = EXIT_FAILURE;
      } else {
         pb = GetNxtBuf();
         if( Integrity_Check(pgsi) ) {
            sprintf(pb, "[%s]", pfile );
            sprintf(EndBuf(pb), ", Headers %ld", pgsi->hdrcnt );
            sprintf(EndBuf(pb), ", Points %ld", pgsi->ptcnt );
            if( VERB8(pgsi) ) {
               sprtf( "v8: File %s ", pb );
               sprtf( " (= %ld bytes)"MEOR,
                  ((pgsi->hdrcnt * sizeof(struct GSHHS))+
                   (pgsi->ptcnt * sizeof(GPOINT))) );
            }
         } else {
            sprintf(pb, "WARNING: File [%s] FAILED itegrity check!", pfile );
            sprtf( "WARNING: %s"MEOR, pb );
         }
         Add_2_Done_List( pb, pgsi->hdrcnt, pgsi->ptcnt );
         iret = Process_GSHHS( pgsi );
         Close_Map_File_WIN32( &pgsi->mv );
      }
      item++;  // bump to NEXT file
      Set_Next_Color( pgsi );
   }

   if(bmp) {
      if( VERB2(pgsi) ) {
         sprtf( "Accumulated %d points on bitmap ...\n",
            pgsi->bmpinfo.range.ptcount );
      }
      //if( pgsi->bmpinfo.range.ptcount )
      Write_User_BMP( pgsi );
   }

   if( VERB3(pgsi) )
   {
      sprtf( "Header Max and Min ...\n" );
      sprtf( "North Max : %10.5f, Min : %10.5f\n",
         pgsi->n_max, pgsi->n_min );
      sprtf( "South Max : %10.5f, Min : %10.5f\n",
         pgsi->s_max, pgsi->s_min );
      sprtf( "East  Max : %10.5f, Min : %10.5f\n",
         pgsi->e_max, pgsi->e_min );
      sprtf( "West  Max : %10.5f, Min : %10.5f\n",
         pgsi->w_max, pgsi->w_min );

      sprtf( "Point Max and Min ...\n" );
      sprtf( "Max lat : %10.5f, Min lat : %10.5f\n",
         pgsi->max_lat, pgsi->min_lat );
      sprtf( "Max lon : %10.5f, Min lon : %10.5f\n",
         pgsi->max_lon, pgsi->min_lon );
   }

#ifndef  NO_ADD_FG_DATA
   Paint_FG_World( pgsi );
#endif // #ifndef  NO_ADD_FG_DATA

   Write_World( DEF_OUT_FILE, pgsi );

#ifdef   WIN32
   if( bmp && pgsi->bmpinfo.execute && pgsi->bmpinfo.exename[0] )
      Run_Process( pgsi ); // use CreateProcess to run IMDisplay bitmap
#endif // #ifdef   WIN32

   pgm_exit( iret );
   return iret;
}

void only_exit( int i )
{
   exit(i);
}


// gshhs_main.c
